"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectSpread2"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutProperties"));
var _axios = _interopRequireDefault(require("axios"));
var _lal = require("lal");
var _excluded = ["auth", "contentType", "debug", "filter", "mono", "onError", "onSuccess", "url"];
var api = function api(props) {
  return new Promise(function (resolve, reject) {
    var _uno = (0, _lal.uno)(props),
      auth = _uno.auth,
      contentType = _uno.contentType,
      debug = _uno.debug,
      _uno$filter = _uno.filter,
      filter = _uno$filter === void 0 ? function (f) {
        return f;
      } : _uno$filter,
      mono = _uno.mono,
      _uno$onError = _uno.onError,
      onError = _uno$onError === void 0 ? function () {} : _uno$onError,
      _uno$onSuccess = _uno.onSuccess,
      onSuccess = _uno$onSuccess === void 0 ? function () {} : _uno$onSuccess,
      url = _uno.url,
      rest = (0, _objectWithoutProperties2.default)(_uno, _excluded);
    var request = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, rest), {}, {
      url: mono || url,
      headers: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, auth && {
        'Authorization': 'Bearer ' + auth
      }), {}, {
        'content-type': contentType || 'application/json'
      })
    });
    if (debug) console.log("lal.api debug at ".concat(debug.location || '', ": starting"), request);
    var recieve = function recieve(toDo, inputObj) {
      var extra = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};
      var message = arguments.length > 3 ? arguments[3] : undefined;
      if (debug) console.log("lal.api completed", message, inputObj);
      var filtered = (0, _objectSpread2.default)((0, _objectSpread2.default)({}, filter(inputObj)), debug && {
        debug: true
      });
      toDo(filtered);
      extra(filtered);
    };
    return (0, _axios.default)(request).then(function (response) {
      return recieve(resolve, response, onSuccess, 'success');
    }).catch(function (error) {
      return recieve(reject, error || {
        message: 'An error occured.'
      }, onError, 'error');
    });
  });
};
var _default = api;
exports.default = _default;