"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useInOut;
var _react = require("react");
function useInOut(_ref) {
  var _ref$boundary = _ref.boundary,
    boundary = _ref$boundary === void 0 ? '' : _ref$boundary,
    debug = _ref.debug,
    disabled = _ref.disabled,
    _ref$onIn = _ref.onIn,
    onIn = _ref$onIn === void 0 ? function () {} : _ref$onIn,
    _ref$onOut = _ref.onOut,
    onOut = _ref$onOut === void 0 ? function () {} : _ref$onOut;
  (0, _react.useEffect)(function () {
    var handleClick = function handleClick(_ref2) {
      var target = _ref2.target;
      var closest = target === null || target === void 0 ? void 0 : target.closest('#' + boundary);
      if (debug) console.log('useInOut debug', debug, target, {
        boundary: boundary,
        closest: closest
      });
      if (closest) onIn({
        target: target
      });else onOut({
        target: target
      });
    };
    if (!disabled) document.addEventListener('mousedown', handleClick, true);else document.removeEventListener('mousedown', handleClick, true);
    return function () {
      return document.removeEventListener('mousedown', handleClick, true);
    };
  }, [boundary, disabled, onIn, onOut]);
}
;