"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useKeyListen;
var _react = require("react");
var _useKeyInput = _interopRequireDefault(require("../useKeyInput"));
function useKeyListen(_ref) {
  var _ref$defaultAll = _ref.defaultAll,
    defaultAll = _ref$defaultAll === void 0 ? true : _ref$defaultAll,
    disabled = _ref.disabled,
    keySet = _ref.keySet,
    keydown = _ref.keydown,
    keyup = _ref.keyup;
  var keyInput = (0, _useKeyInput.default)({
    defaultAll: defaultAll,
    disabled: disabled,
    keySet: keySet,
    keydown: keydown,
    keyup: keyup
  });
  (0, _react.useEffect)(function () {
    if (!disabled) {
      if (!keyup || keydown && keyup) document.addEventListener('keydown', keyInput);
      if (!keydown || keydown && keyup) document.addEventListener('keyup', keyInput);
      return function () {
        document.removeEventListener('keydown', keyInput);
        document.removeEventListener('keyup', keyInput);
      };
    }
  }, [defaultAll, disabled, keydown, keyInput, keySet, keyup]);
}
;