"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = usePagination;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectSpread2"));
var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/toConsumableArray"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));
var _react = require("react");
function usePagination(_ref) {
  var _ref$at = _ref.at,
    at = _ref$at === void 0 ? 0 : _ref$at,
    _ref$count = _ref.count,
    count = _ref$count === void 0 ? 0 : _ref$count,
    debug = _ref.debug,
    pause = _ref.pause,
    _ref$name = _ref.name,
    name = _ref$name === void 0 ? '' : _ref$name,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange;
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    active = _useState2[0],
    setActive = _useState2[1];
  var _useState3 = (0, _react.useState)(at),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    page = _useState4[0],
    setPage = _useState4[1];
  var _useState5 = (0, _react.useState)(at),
    _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
    internal = _useState6[0],
    setInternal = _useState6[1];
  var _useState7 = (0, _react.useState)(at),
    _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
    external = _useState8[0],
    setExternal = _useState8[1];
  var _useState9 = (0, _react.useState)(true),
    _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
    direction = _useState10[0],
    setDirection = _useState10[1];
  var _useState11 = (0, _react.useState)([]),
    _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
    pageHistory = _useState12[0],
    setPageHistory = _useState12[1];
  var atStart = page <= 0;
  var atEnd = page >= count - 1;
  var goTo = function goTo(index) {
    var check = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
    if (check) {
      setPageHistory([].concat((0, _toConsumableArray2.default)(pageHistory), [page]));
      setInternal(index);
    }
  };
  var back = function back(check) {
    return goTo(page - 1, check);
  };
  var forward = function forward(check) {
    return goTo(page + 1, check);
  };
  var previous = function previous() {
    if (pageHistory.length > -1) {
      var newHistory = (0, _toConsumableArray2.default)(pageHistory);
      setInternal(pageHistory[pageHistory.length - 1]);
      newHistory.pop();
      setPageHistory(newHistory);
    }
  };
  (0, _react.useEffect)(function () {
    var active = true;
    if (active && !pause) {
      var execute = function execute(index) {
        var num = parseInt(index);
        onChange({
          target: (0, _objectSpread2.default)((0, _objectSpread2.default)({}, name && {
            name: name
          }), {}, {
            value: num
          })
        });
        setActive(true);
        setDirection(num > page);
        num > -1 && num < count && setPage(num);
      };
      if (at !== external) {
        setInternal(at);
        setExternal(at);
      } else if (internal !== page) execute(internal);
    }
    return function () {
      active = false;
    };
  }, [at, count, external, name, onChange, page, pause, internal, setActive, setDirection, setPage, setInternal]);
  return {
    active: active,
    atEnd: atEnd,
    atStart: atStart,
    back: back,
    count: count,
    direction: direction,
    forward: forward,
    goTo: goTo,
    page: page,
    previous: previous,
    setActive: setActive,
    setPage: setPage
  };
}
;