"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useRelay;
var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectSpread2"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutProperties"));
var _react = require("react");
var _lal = require("lal");
var _useRequest2 = _interopRequireDefault(require("../useRequest"));
var _excluded = ["debug", "delay", "onError", "onSuccess", "paused", "mono", "retry", "slowOnError", "url", "watch"],
  _excluded2 = ["error", "request"];
function useRelay(props) {
  var _uno = (0, _lal.uno)(props),
    debug = _uno.debug,
    delay = _uno.delay,
    _uno$onError = _uno.onError,
    _onError = _uno$onError === void 0 ? function () {} : _uno$onError,
    _uno$onSuccess = _uno.onSuccess,
    _onSuccess = _uno$onSuccess === void 0 ? function () {} : _uno$onSuccess,
    paused = _uno.paused,
    mono = _uno.mono,
    retry = _uno.retry,
    slowOnError = _uno.slowOnError,
    url = _uno.url,
    watch = _uno.watch,
    rest = (0, _objectWithoutProperties2.default)(_uno, _excluded);
  var _useState = (0, _react.useState)(paused ? -1 : 0),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    status = _useState2[0],
    setStatusState = _useState2[1];
  var setStatus = (0, _react.useCallback)(function (input) {
    var instance = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    if (debug) console.debug("useRelay setStatus at ".concat(debug.location || ''), {
      instance: instance,
      input: input
    });
    setStatusState(input);
  }, [debug]);
  var execute = function execute(res, step, onFinish) {
    onFinish(res);
    setStatus(step, 'useRelay internal execute'); // 2 || 3
  };

  var _useRequest = (0, _useRequest2.default)((0, _objectSpread2.default)({
      debug: debug,
      onError: function onError(res) {
        return execute(res, retry ? 0 : 3, _onError);
      },
      onSuccess: function onSuccess(res) {
        return execute(res, 2, _onSuccess);
      },
      url: mono || url
    }, rest)),
    error = _useRequest.error,
    request = _useRequest.request,
    requestProps = (0, _objectWithoutProperties2.default)(_useRequest, _excluded2);
  (0, _react.useEffect)(function () {
    if (!status) {
      setStatus(1, 'useRelay useEffect status = 0/falsy');
      request();
    }
  }, [request, setStatus, status]);
  return (0, _objectSpread2.default)({
    error: error,
    hold: !status || status === 1,
    request: request,
    // function to trigger API request directly
    status: status,
    // -1: paused, 0: staged (will trigger request), 1: processing, 2: success, 3: error
    setStatus: setStatus
  }, requestProps);
}
;