"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = useRequest;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/defineProperty"));
var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectSpread2"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectWithoutProperties"));
var _react = require("react");
var _lal = require("lal");
var _resources = require("../resources");
var _excluded = ["apiKey", "baseURL", "debug", "baseState", "key", "keyName", "onError", "onSuccess", "params", "mono", "url"];
var _process$env = process.env,
  mainKey = _process$env.REACT_APP_API_MAIN_KEY,
  mainKeyName = _process$env.REACT_APP_API_MAIN_KEY_NAME,
  mainURL = _process$env.REACT_APP_API_MAIN_URL;
function useRequest(props) {
  var _uno = (0, _lal.uno)(props),
    apiKey = _uno.apiKey,
    baseURL = _uno.baseURL,
    debug = _uno.debug,
    baseState = _uno.baseState,
    key = _uno.key,
    keyName = _uno.keyName,
    _uno$onError = _uno.onError,
    _onError = _uno$onError === void 0 ? function () {} : _uno$onError,
    _uno$onSuccess = _uno.onSuccess,
    _onSuccess = _uno$onSuccess === void 0 ? function () {} : _uno$onSuccess,
    params = _uno.params,
    mono = _uno.mono,
    url = _uno.url,
    rest = (0, _objectWithoutProperties2.default)(_uno, _excluded);
  var _useState = (0, _react.useState)(null),
    _useState2 = (0, _slicedToArray2.default)(_useState, 2),
    error = _useState2[0],
    errorSet = _useState2[1];
  var _useState3 = (0, _react.useState)(),
    _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
    httpCode = _useState4[0],
    httpCodeSet = _useState4[1];
  var _useState5 = (0, _react.useState)(baseState),
    _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
    response = _useState6[0],
    responseSet = _useState6[1];
  var resetState = function resetState(_ref) {
    var keepContent = _ref.keepContent,
      keepError = _ref.keepError;
    if (debug) console.debug("hangers debug reset state at ".concat(debug.location || '', ", baseState:"), baseState);
    if (!keepContent) responseSet(baseState);
    if (!keepError) errorSet(null);
  };
  var resArr = ['error', 'success'];
  var execute = function execute() {
    var res = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var updateState = arguments.length > 1 ? arguments[1] : undefined;
    var onFinish = arguments.length > 2 ? arguments[2] : undefined;
    var clear = arguments.length > 3 ? arguments[3] : undefined;
    var pass = arguments.length > 4 ? arguments[4] : undefined;
    var resObj = pass ? (0, _objectSpread3.default)((0, _objectSpread3.default)({}, baseState), res.data) : res.data || {};
    if (debug) console.debug("hangers useRequest execute at ".concat(debug.location || ''), resArr[pass], resObj);
    if (res.status) httpCodeSet(res.status);
    updateState(resObj);
    clear(pass ? null : baseState);
    onFinish(resObj);
  };
  var queryObj = (0, _objectSpread3.default)((0, _defineProperty2.default)({}, keyName || mainKeyName || key ? 'key' : 'apiKey', key || apiKey || mainKey), params);
  var request = function request() {
    return (0, _resources.api)((0, _objectSpread3.default)({
      baseURL: baseURL || mainURL,
      debug: debug,
      onError: function onError(err) {
        return execute(err.response, errorSet, _onError, responseSet, 0);
      },
      onSuccess: function onSuccess(res) {
        return execute(res, responseSet, _onSuccess, errorSet, 1);
      },
      params: queryObj,
      url: mono || url
    }, rest)).then(function (res) {
      return (0, _lal.log)(undefined, {
        hangersDebug: 'success',
        res: res
      }, res.debug);
    }).catch(function (err) {
      return (0, _lal.log)(undefined, {
        hangersDebug: 'error',
        err: err
      }, err.debug);
    });
  };
  return {
    error: error,
    errorSet: errorSet,
    httpCode: httpCode,
    httpCodeSet: httpCodeSet,
    request: request,
    response: response,
    responseSet: responseSet,
    resetState: resetState
  };
}
;